part of 'floative_factory.dart';

class _Factory<T> {
  T instance;
  InstanceFunction<T> instanceFunction;
  _FactoryType factoryType;

  _Factory({this.instanceFunction, this.factoryType}) {
    if (factoryType == _FactoryType.singleton) {
      instance = instanceFunction();
    }
  }

  T getInstance() {
    switch (factoryType) {
      case _FactoryType.lazy:
        if (instance == null) {
          instance = instanceFunction();
        }
        return instance;
      case _FactoryType.singleton:
        return instance;
      case _FactoryType.factory:
      default:
        return instanceFunction();
    }
  }
}

enum _FactoryType { factory, singleton, lazy }

typedef InstanceFunction<T> = T Function();
